#!/usr/bin/python
# -*- coding: koi8-r -*-
import locale

def parse_with_quotes(s):
        res = list()
        ns = ''
        waitclose = None
        for c in s:
                if waitclose:
                        if c == waitclose:
                                if waitclose == ')':
                                        ns += c
                                waitclose = None
                        else:
                                ns += c
                else:
                        if c == '"':
                                waitclose = '"'
                        elif c == '(':
                                ns += c
                                waitclose = ')'
                        elif c == ',': #delimiter
                                ns = ns.lstrip().rstrip()
                                res.append(ns)
                                ns = ''
                        else:
                                ns += c
        ns = ns.lstrip().rstrip()
        res.append(ns)

        return res

def split_by_comma(s, num):
        l = map(lambda a: int(a.lstrip().rstrip()), s.split(','))
        res = list()
        for i in xrange(len(l) / num):
                res.append(l[i * num : i * num + num])

        return res

def read_full_section(cp, section):
        res = list()
        try:
                for i in cp.options(section):
                        res.append(map(lambda a: a.rstrip().lstrip(), parse_with_quotes(cp.get(section, i))))
        except Exception, e:
                print e
                pass
        return res

class ReadMap:
        def __init__(self, datafile):
                locale.setlocale(locale.LC_ALL, '')
                self.ini = datafile
                self.inited = False
                self.Map = dict()
                self.StNames = dict()
                self.StNumbers = dict()
                self.StCoordinates = dict()
                self.LineNames = dict()
                self.LineNumbers = dict()
                self.LineCoordinates = dict()
                self.Graph = list()
                self.MapEncoding = 'koi8-r'
                self.delaytime = 'delayday'
                if self._load():
                        self.inited = True
                        self._makeGraph()

                        if 0: #change to 1 to produce datafile parsable by doc/findpath.c
                                print len(self.Graph)
                                for k in self.Graph:
                                        print len(k)
                                        for ge in k:
                                                for e in ge:
                                                        print e
                                print len(self.Map['linenumbers'])
                                for line in self.Map['linenumbers']:
                                        print line
                                        print self.Map[line]['delayday']
                                        print self.Map[line]['delaynight']

        def SetDelayTime(self, dtime):
                if dtime == 1 or dtime == '1' or \
                   (type(dtime) == str and dtime.lower() == 'night'):
                        self.delaytime = 'delaynight'
                else:
                        self.delaytime = 'delayday'

        def WaitLen(self, station):
                return float(self.Map[self.StNames[station][1]][self.delaytime])

        def PathLen(self, path):
                jumps = 0
                plen = float(0)
                plen += float(self.Map[self.StNames[path[0]][1]][self.delaytime])
                prev = path[0]
                nowstep = 0
                for st in path[1:]:
                        nowstep += 1
                        for g in xrange(len(self.Graph[prev])):
                                if self.Graph[prev][g][0] == st:
                                        plen += float(self.Graph[prev][g][1])
                                        if self.StNames[prev][1] != self.StNames[st][1] and st != path[-1]:
                                                if nowstep == 1:
                                                        plen -= float(self.Map[self.StNames[path[0]][1]][self.delaytime])
                                                plen += float(self.Map[self.StNames[st][1]][self.delaytime])
                                                jumps += 1
                                        prev = st
                                        break
                return plen, jumps

        def FindLineByPart(self, partname):
                lines = list()
                for i in self.LineNumbers:
                        if i.lower().find(partname.lower()) != -1:
                                lines.append(i)
                return lines

        def FindStatByPart(self, partname):
                stations = list()
                for i in self.StNumbers:
                        if i[0].lower().find(partname.lower()) != -1:
                                stations.append(i)
                return stations

        def __count_lu__(self, s):
                locale.setlocale(locale.LC_ALL, 'ru_RU.KOI8-R')
                __up = len(filter(lambda a: a.isupper(), s))
                self.__uppers += __up
                self.__lowers += len(s) - __up
                locale.setlocale(locale.LC_ALL, '')

        def _makeGraph(self):
                numstations = 0
                self.__lowers = 0
                self.__uppers = 0
                for line in self.Map['linenumbers']:
                        self.LineCoordinates[line] = dict()
                        self.LineCoordinates[line]['color'] = self.Map[line]['color']
                        self.LineCoordinates[line]['diameter'] = self.Map['diameter']
                        self.LineCoordinates[line]['stations'] = list()
                        self.LineNames[line] = self.Map[line]['name']
                        self.LineNumbers[self.Map[line]['name']] = line
                        for station in xrange(len(self.Map[line]['names'])):
                                self.__count_lu__(self.Map[line]['names'][station])
                                self.StNames[numstations] = (self.Map[line]['names'][station], line)
                                self.StNumbers[(self.Map[line]['names'][station], line)] = numstations
                                if not (self.Map[line]['coordinates'][station][0] == 0 and
                                        self.Map[line]['coordinates'][station][1] == 0):
                                                self.LineCoordinates[line]['stations'].append([numstations,
                                                                                               self.Map[line]['coordinates'][station],
                                                                                               self.Map[line]['names'][station]])
                                                self.StCoordinates[numstations] = [self.Map[line]['coordinates'][station],
                                                                                   self.Map['diameter'],
                                                                                   self.Map[line]['rects'][station]]
                                self.Graph.append(list())
                                numstations += 1

                if self.__lowers < self.__uppers:
                        self.MapEncoding = 'cp1251'

                self.StCoordinatesAdd = dict()
                for node in self.Map['addnodes']:
                        fr = self.StNumbers[(node[1], self.LineNumbers[node[0]])]
                        to = self.StNumbers[(node[2], self.LineNumbers[node[0]])]
                        spline = False
                        lastel = None
                        if node[-1] == 'spline':
                                spline = True
                                lastel = -1
                        l = map(lambda a: int(a), node[3:lastel])
                        self.StCoordinatesAdd[(fr, to)] = [spline] + l
                        nl = list()
                        for i in xrange(len(l) / 2):
                                nl.append(l[-(i * 2) - 2])
                                nl.append(l[-(i * 2) - 1])
                        self.StCoordinatesAdd[(to, fr)] = [spline] + nl

                for line in self.Map['linenumbers']:
                        for st in xrange(len(self.Map[line]['names'])):
                                s_from = self.StNumbers[self.Map[line]['names'][st], line]
                                for n in self.Map[line]['neighbours'][st]:
                                        s_to = self.StNumbers[self.Map[line]['names'][n[0]], line]
                                        if not [s_to, float(n[1]), line, line] in self.Graph[s_from]:
                                                self.Graph[s_from].append([s_to, float(n[1]), line, line])
                                        if not [s_from, float(n[1]), line, line] in self.Graph[s_to]:
                                                self.Graph[s_to].append([s_from, float(n[1]), line, line])

                for transfers in self.Map['transfers']:
                        lf = self.LineNumbers[transfers[0]]
                        lt = self.LineNumbers[transfers[2]]
                        sf = self.StNumbers[transfers[1], lf]
                        st = self.StNumbers[transfers[3], lt]
                        d = float(transfers[4])
                        self.Graph[sf].append([st, d, lf, lt])
                        self.Graph[st].append([sf, d, lt, lf])

                #workaround broken data files
                for ki in xrange(len(self.Graph)):
                        tor = list()
                        for i in xrange(len(self.Graph[ki]) - 1):
                                for j in xrange(i + 1, len(self.Graph[ki])):
                                        if self.Graph[ki][i][0] == self.Graph[ki][j][0]:
                                                tor.append(self.Graph[ki][j])
                                                #print '"' + self.StNames[ki][0] + '"',
                                                #print '"' + self.StNames[self.Graph[ki][i][0]][0] + '"',
                                                #print '(' + self.LineNames[self.StNames[ki][1]] + ')',
                                                #print self.Graph[ki][i][1], self.Graph[ki][j][1]
                        if tor:
                                #print tor
                                for r in tor:
                                        self.Graph[ki].remove(r)

        def _load(self):
                import ConfigParser

                cp = ConfigParser.RawConfigParser()
                try:
                        try:
                                cp.readfp(open(self.ini))
                        except:
                                pass
                        sec = cp.sections()
                        lsec = map(lambda a: a.lower(), sec)
                        s = sec[lsec.index('options')]
                        self.Map['city']     = cp.get(s, 'cityname')
                        self.Map['image']    = cp.get(s, 'imagefilename')
                        self.Map['diameter'] = int(cp.get(s, 'stationdiameter'))
                        self.Map['linenumbers'] = list()
                        for nows in lsec:
                                if nows.startswith('line') and len(nows[4:]):
                                        linenum = nows[4:]
                                        s = sec[lsec.index(nows)]

                                        self.Map[linenum] = dict()
                                        self.Map[linenum]['circled'] = False
                                        self.Map['linenumbers'].append(linenum)

                                        for opt in 'name', 'color', 'delayday', 'delaynight':
                                                self.Map[linenum][opt] = cp.get(s, opt)
                                        try:
                                                self.Map[linenum]['labelscolor'] = cp.get(s, 'labelscolor')
                                        except:
                                                self.Map[linenum]['labelscolor'] = 'ffffff'

                                        self.Map[linenum]['coordinates'] = split_by_comma(cp.get(s, 'coordinates'), 2)
                                        self.Map[linenum]['rects'] = split_by_comma(cp.get(s, 'rects'), 4)

                                        names = parse_with_quotes(cp.get(s, 'names'))
                                        drive = parse_with_quotes(cp.get(s, 'driving'))
                                        self.Map[linenum]['names'] = list()
                                        for i in xrange(len(names)):
                                                if not len(names[i]):
                                                        continue
                                                if names[i].find('(') != -1:
                                                        nowst = names[i][:names[i].index('(')]
                                                else:
                                                        nowst = names[i]
                                                #workaround duplicate station names
                                                if nowst in self.Map[linenum]['names']:
                                                        nowst += ' [' + str(i) + ']'
                                                self.Map[linenum]['names'].append(nowst)

                                        self.Map[linenum]['neighbours'] = list()
                                        for i in xrange(len(names)):
                                                if not len(names[i]):
                                                        continue
                                                self.Map[linenum]['neighbours'].append([])
                                                if names[i].find('(') != -1:
                                                        jnames = map(lambda a: a.lstrip('-'), parse_with_quotes(names[i][names[i].index('(') + 1:-1]))
                                                        if drive[i][0] == '(':
                                                                jdrives = drive[i][1:-1].split(',')
                                                        else:
                                                                if drive[i].lstrip().rstrip() == "":
                                                                        drive[i] = '0'
                                                                jdrives = [drive[i]] * len(jnames)
                                                        for j in xrange(len(jnames)):
                                                                if not len(jnames[j]):
                                                                        continue
                                                                self.Map[linenum]['neighbours'][-1].append((self.Map[linenum]['names'].index(jnames[j]), jdrives[j]))
                                                else:
                                                        if i < len(names) - 1:
                                                                t = drive[i]
                                                                if drive[i][0] == '(':
                                                                        t = drive[i][1:-1].split(',')[1]
                                                                self.Map[linenum]['neighbours'][-1].append((i + 1, t))

                        self.Map['addnodes'] = read_full_section(cp, sec[lsec.index('additionalnodes')])
                        self.Map['transfers'] = read_full_section(cp, sec[lsec.index('transfers')])

                except:
                        del cp
                        return False

                del cp
                return True
