#!/usr/bin/python
import gtk
import gnome.canvas

points = [(100, 30), (180, 70), (200, 100), (180, 120), (220, 120), (250, 120), (280, 120)]
#points = [(518,348), (548,350), (570,367), (576,389), (576,412)]
#points = [(669,434), (696,435), (723,443), (734,465), (736,487)]
#points = [(174,363), (175,393), (184,421), (209,432), (240,434)]
maxx = max(map(lambda a: a[0], points)) + 20
maxy = max(map(lambda a: a[1], points)) + 20
win = gtk.Window()
win.set_default_size(maxx + 40, maxy + 40)
swin = gtk.ScrolledWindow()
swin.set_shadow_type(gtk.SHADOW_IN)
swin.set_policy(gtk.POLICY_ALWAYS, gtk.POLICY_ALWAYS)
win.add(swin)

canvas = gnome.canvas.Canvas(aa = True)
#canvas.set_size_request(300, 300)
canvas.set_scroll_region(0, 0, maxx, maxy)
swin.add(canvas)

root = canvas.root()
rect = root.add(gnome.canvas.CanvasRect, outline_color = "black", fill_color = "white", x1 = 0, y1 = 0, x2 = maxx, y2 = maxy)

bp = root.add(gnome.canvas.CanvasBpath, outline_color="blue", width_pixels= 6, cap_style=gtk.gdk.CAP_NOT_LAST)

delta = 20

guide = []
path = []
#path.append((gnome.canvas.MOVETO, points[0][0] - 30, points[0][1] - 30))
path.append((gnome.canvas.MOVETO, points[0][0], points[0][1]))

def find_cross(lx1, ly1, lx2, ly2, x, y):
        a = lx2 - lx1
        b = ly2 - ly1
        c = a * x + b * y
        d = b
        e = -a
        f = d * lx1 + e * ly1
        g = a * e - b * d
        return float((c * e - b * f) / g), float((a * f - c * d) / g)

prevcx, prevcy = points[0]
for i in xrange(len(points) - 2):
        nx, ny = find_cross(points[i][0], points[i][1], points[i + 2][0], points[i + 2][1], points[i + 1][0], points[i + 1][1])
        ax = points[i][0] - (nx - points[i + 1][0])
        ay = points[i][1] - (ny - points[i + 1][1])
        bx = points[i + 2][0] - (nx - points[i + 1][0])
        by = points[i + 2][1] - (ny - points[i + 1][1])

        div = 2
        ex = nx - float((nx - points[i][0]) / div)
        ey = ny - float((ny - points[i][1]) / div)
        fx = nx + float((points[i + 2][0] - nx) / div)
        fy = ny + float((points[i + 2][1] - ny) / div)

        cx, cy = find_cross(bx, by, ax, ay, ex, ey)

        print 'n:', nx, ny, 'a:', ax, ay, 'b:', bx, by, 'e:', ex, ey, 'c:', cx, cy

        path.append((gnome.canvas.CURVETO, prevcx, prevcy, cx, cy, points[i + 1][0], points[i + 1][1]))
        guide.append((prevcx, prevcy))
        guide.append((cx, cy))
        prevcx, prevcy = find_cross(bx, by, ax, ay, fx, fy)

path.append((gnome.canvas.CURVETO, prevcx, prevcy, points[-1][0], points[-1][1], points[-1][0], points[-1][1]))
guide.append((prevcx, prevcy))

#path.append((gnome.canvas.LINETO, points[-1][0] + 30, points[-1][1]))
#hack to make path "open"
path.append((gnome.canvas.MOVETO, 0, 0))

path_def = gnome.canvas.path_def_new(path)
bp.set_bpath(path_def)

if 0:
        for p in points:
                root.add(gnome.canvas.CanvasRect, outline_color = "red", fill_color = None,
                         x1 = p[0], y1 = p[1], x2 = p[0] + 1, y2 = p[1] + 1)
                print 'p:', p[0], p[1]
        if 0:
                for p in guide:
                        root.add(gnome.canvas.CanvasRect, outline_color = "green", fill_color = None,
                                 x1 = p[0], y1 = p[1], x2 = p[0] + 1, y2 = p[1] + 1)
                        print 'g:', p[0], p[1]

win.show_all()
win.connect('destroy', gtk.main_quit)
gtk.main()
