#!/usr/bin/python
# -*- coding: koi8-r -*-
import sys
sys.path.insert(1,'../modules/')

from ReadMap import ReadMap
from FindPath import FindPath

#MetroMap = ReadMap("../data/Moscow/Metro.ini")
MetroMap = ReadMap("../data/London/Metro.ini")

if not MetroMap.inited:
        print 'Cannot load map'
        sys.exit(0)

Finder = FindPath(MetroMap.Graph)

if len(sys.argv) == 2 and sys.argv[1] == 'timetest':
        import datetime
        maxtime = datetime.timedelta(0)
        maxtimestat = datetime.timedelta(0)
        maxjumps = 0
        frst = 0
        tost = 0
        msl = MetroMap.StNumbers.values()
        msl.sort()
        for fr in msl:
                print fr, MetroMap.StNames[fr][0], '(' + MetroMap.LineNames[MetroMap.StNames[fr][1]] + ')'
                startstat = datetime.datetime(100, 1, 1).now()
                for to in MetroMap.StNumbers.itervalues():
                        #print 'to:', to, MetroMap.StNames[to][0], '(' + MetroMap.LineNames[MetroMap.StNames[to][1]] + ')'
                        start = datetime.datetime(100, 1, 1).now()
                        plist = Finder.waves_accurate(fr, to, MetroMap.WaitLen)
                        if not len(plist):
                                print 'not found:', fr, to
                                sys.exit(0)
                        finish = datetime.datetime(100, 1, 1).now()
                        if (finish - start) > maxtime:
                                maxtime = finish - start
                                frst = fr
                                tost = to
                                print maxtime, fr, to, '(' + MetroMap.StNames[fr][0], MetroMap.StNames[to][0] + ')'

                finishstat = datetime.datetime(100, 1, 1).now()
                md = finishstat - startstat
                if md > maxtimestat:
                        maxtimestat = md
                        print 'Max:', md

        sys.exit(0)

if len(sys.argv) != 3:
        print "Usage:", sys.argv[0], "'from station [, line]' 'to station [, line]'"
        print "station and line names can be specifed partialy"
        sys.exit(0)

def prstation(st):
        return st[0] + ' (' + MetroMap.LineNames[st[1]] + ')'

def findstlist(st):
        if st.isdigit():
                return [MetroMap.StNames[int(st)]]
        pair = map(lambda a: a.lstrip().rstrip(), st.split(','))
        fromlist = MetroMap.FindStatByPart(pair[0])
        if len(pair) == 2:
                nlist = list()
                frlinelist = MetroMap.FindLineByPart(pair[1])
                for f in fromlist:
                        for line in frlinelist:
                                if f[1] == MetroMap.LineNumbers[line]:
                                        nlist.append(f)
                fromlist = nlist
        return fromlist

fromlist = findstlist(sys.argv[1])
tolist = findstlist(sys.argv[2])

def printpath(path):
        step = 0
        pvl = 0
        for i in path:
                if step > 0:
                        if MetroMap.StNames[i][1] != MetroMap.StNames[pvl][1]:
                                print "-'~`->",
                        else:
                                print '->',
                pvl = i
                print MetroMap.StNames[i][0], '(' + MetroMap.LineNames[MetroMap.StNames[i][1]] + ')',
                step += 1
        print

for f in fromlist:
        for t in tolist:
                print 'Going from "' + prstation(f) + '" to "' + prstation(t)
                plist = Finder.waves_accurate(MetroMap.StNumbers[f[0], f[1]], MetroMap.StNumbers[t[0], t[1]], MetroMap.WaitLen)
#                plist = Finder.minjumps(MetroMap.StNumbers[f[0], f[1]], MetroMap.StNumbers[t[0], t[1]], 10)
                if len(plist):
                        for p in plist:
                                print ' -', p[0], ' -', p[1],
                                printpath(p[2:])
